#<profile4xi profile = "12" /> 
# =================================================================================================
#<program4xi program = "lpu2buffer4xi.py">
#<abstract4xi abstract = "LPU buffer management"/>
#<refer4xi reference = "buffer4xi.py"/>
#<verify4xi verification = "10" target = "lpu3image4xi.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'LPU2Buffer4Xi',  
            'create2buffer4lpu',
            'create2subbuffer4lpu',
            'get2bufferinfo4lpu',
            'release2buffer4lpu',
            'retain2buffer4lpu',
            'set2buffer4lpu',
            'trace2buffer4lpu'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   

from decimal import *
from ctypes import Structure, c_double
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from lpu2context4xi import get2context4lpu
from lpu2device4xi import get2lpu4xi
from platformids4xi  import get2platformids4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from print4xi import print4xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                             
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global lpu2buffer4xi                                                    # Buffer of LPU 
global lpu2subbuffer4xi                                                 # Sub-buffer of LPU 
global lpu2trace4xi                                                     # TRACE

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2buffer4lpu" usage = "
#
#  task4create2lpu = {}                                                                                            
#  task4create2lpu= {}      
#  task4create2lpu['FUNCTION2CALLBACK'] = trace2buffer4lpu                                                                 # CALLBACK FUNCTION CALLED BY LPUIZED OPENCL
#
#  args2callback = {}                                                                                                           
#  args2callback['CLASS']   = "create2buffer4lpu"                                                                             # MODULE OF LPUIZED OPENCL MODULE
#  args2callback['METHOD']  = "create2buffer4lpu"                                                                             # FUNCTION OF LPUIZED OPENCL MODULE
#  args2callback['MESSAGE'] = "{(Step 2Z1/33) failed" + "; create2buffer4lpu-failed " + "; time: " + time4xi() + "}"          # ERROR MESSAGE FOR LPUIZED OPENCL TO RETURN    
#  
#  task4create2lpu['ARGS2CALLBACK'] = args2callback                                                                           # MAX ONE ARG - THEREFORE GIVE SEVERAL ARGS IN ONE DICTIONARY 
#  
#  response4create2buffer = {}
#  print('(Step 1A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO CREATE BUFFER FOR LPU ', time4xi())  
#  try:                               
#      response4create2buffer = create2buffer4lpu (task4create2lpu)                                                        # EXAMINE RESPONSE!                                                      
#      print('(Step 1B/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4CREATE2BUFFER: ', response4create2buffer)                          # trace2buffer4lpu CALLED BY LPUIZED OPENCL IN EXCEPTIONS - CHECK LPUIZED TRACE!                       
#  except: 
#      print('(Step Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO CREARE BUFFER FOR LPU ', time4xi())  
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2buffer4lpu(task4trace2lpu=None):

    '''
    trace for lpu2buffer4xi
    '''
    
    global lpu2trace4xi 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2buffer4lpu" 
    method2print = "trace2buffer4lpu"

    message2print = "{(Step 1A/33) started" + "; trace2buffer4lpu-started: " + str(trace2buffer4lpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2lpu-to-trace2buffer4lpu: " + str(task4trace2lpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    lpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2lpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY LPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2lpu = {}                                                                                            
            
        task4trace2lpu= {} 
  
        message2print = "{(Step 2A/33) warned" + "; task4trace2lpu-warned-by-trace2buffer4lpu to: " + str(task4trace2lpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
        code2nack = code2nack + '2A-'            

    else:
        # -----------------------------------------------------------------------------------------
        # PARAMETER GIVEN BY LPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------          
        message2print = "{(Step 3A/33) try" + "; task4trace2lpu-try-by-trace2buffer4lpu: " + str(task4trace2lpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 

        try:
            class2print   = task4trace2lpu['CLASS']                                                               # LPUIZE LPU TRACE!
            method2print  = task4trace2lpu['METHOD']
            message2print = task4trace2lpu['MESSAGE']
            print4xi(class2print, method2print, message2print)                                                       # LPUIZED TRACE FOR OPENCL CALLBACK!
            # =================================
            # 
            # =================================
            
            class2print = "trace2buffer4lpu"                                                                      # SET TRACE BACK TO THIS FUNCTION!
            method2print = "trace2buffer4lpu"                
            message2print = "{(Step 3B/33) performed" + "; lpu-trace-performed-by-trace2buffer4lpu: " + str(task4trace2lpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 

            code2ack = code2ack + '3B-' 
        except:
            message2print = "{(Step 3Z1/33) failed" + "; lpu-trace-failed-by-trace2buffer4lpu: " + str(task4trace2lpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            code2nack = code2nack + '3Z1-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; trace2buffer4lpu-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    # 
    
    return
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2buffer4lpu" usage = "
#     
#   buffer4xi = {}        
#   try:
#       buffer4xi['LPU'] = create2buffer4lpu()                                                              # LPU buffer      
#       message2print = "{(Step 2B/33) initialized" + "; lpu-buffer4xi-initialized-by-create2buffer4xi to: " + str(buffer4xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)     
#       ....                                                                                                      # buffer of devices
#   except:
#       message2print = "{(Step 3Z1/33) yielded" + "; buffer4xi-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                              
#
#">

# -------------------------------------------------------------------------------------------------   
def create2buffer4lpu(task4create2lpu=None):

    '''
    creates lpu2buffer4xi
    '''
    
    global lpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2buffer4lpu" 
    method2print = "create2buffer4lpu"

    message2print = "{(Step 1A/70) started" + "; create2buffer4lpu-started: " + str(create2buffer4lpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2buffer4lpu at 0x00000000037ADF48> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2lpu-to-create2buffer4lpu: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None

    code2ack  = ' '
    code2nack = ' '    
    
    lpu2buffer4xi = {}                                                                                        # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2lpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO LPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4create2lpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2lpu-initialized-by-create2buffer4lpu to: " + str(task4create2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            function2callback4lpu = trace2buffer4lpu                                                        # CALLBACK FUNCTION FOR LPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4lpu-initialized-by-create2buffer4lpu to: " + str(function2callback4lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2buffer4lpu at 0x00000000037B5B48>
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                   # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2buffer4lpu"                                                    # MODULE OF LPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2buffer4lpu"                                                    # FUNCTION OF LPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2buffer4lpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR LPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-initialized-by-create2buffer4lpu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4lpu-failed ; time: 02:07:07 05/23/11 Pacific Daylight Time}', 
            #  'CLASS': 'create2buffer4lpu', 'METHOD': 'create2buffer4lpu'}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 

            code2ack  = code2ack + '1E-'
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACK - EXTRA                      
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu['DATA2CALLBACK'] = args2callback                                                   # USER DATA PASSED TO LPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2lpu['FUNCTION2CALLBACK'] = function2callback4lpu                                    # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) set" + "; task4create2lpu-initialized-by-create2buffer4lpu to: " + str(task4create2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2buffer4lpu at 0x00000000037B5B48>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4lpu-failed ; time: 02:07:07 05/23/11 Pacific Daylight Time}', 
            #  'CLASS': 'create2buffer4lpu', 'METHOD': 'create2buffer4lpu'}}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 
            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-initialized-by-create2buffer4lpu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2buffer4lpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 02:07:07 05/23/11 Pacific Daylight Time}
    
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2buffer4lpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4create2lpu['PLATFORM'] = platform2xi                                                            # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            context2lpu = None
            message2print = "{(Step 3A/70) trying" + "; context2lpu-trying-by-create2buffer4lpu: " + str(context2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2lpu = get2context4lpu()                                                               # NO PARAMETERS - THE SYSTEM CREATES   
                
                message2print = "{(Step 3B/70) got" + "; context2lpu-got-by-create2buffer4lpu: " + str(context2lpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 02:07:07 05/23/11 Pacific Daylight Time}', 
                #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x00000000037A5448>, 
                #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
                #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
                #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2lpu-failed-by-create2buffer4lpu: " + str(context2lpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
            task4create2lpu ['CONTEXT'] = context2lpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - EXTRA                           
            # ---------------------------------------------------------------------------------------------    
            device2lpu = None
            message2print = "{(Step 4A/70) trying" + "; device2lpu-trying-by-create2buffer4lpu: " + str(device2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2lpu = get2lpu4xi()                                                                     # NO PARAMETERS - THE SYSTEM CREATES    
                
                message2print = "{(Step 4B/70) got" + "; device2lpu-got-by-create2buffer4lpu: " + str(device2lpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 
                #  'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16,
                #  'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4,
                #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536,
                #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
                #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
                #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64,
                #  'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK',
                #  'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
                #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
                #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033,
                #  'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD',
                #  'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16,
                #  'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
                #  'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128,
                #  'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_LPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2lpu-failed-by-create2buffer4lpu: " + str(device2lpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4create2lpu ['DEVICE'] = device2lpu
            
            # ---------------------------------------------------------------------------------------------
            # (6) DEFINE FLAGS - REQUIRED                           
            # ---------------------------------------------------------------------------------------------         
            task4create2lpu ['FLAGS'] = 0b00000000000000000000000000000000
            message2print = "{(Step 6A/70) initialized" + "; flags-initialized-by-create2buffer4lpu to: " + str(task4create2lpu ['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '6A-'         
        
            # ---------------------------------------------------------------------------------------------
            # (7) DEFINE SIZE OF MEMORY OBJECT - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4create2lpu ['SIZE'] = 8192*34
            message2print = "{(Step 7A/70) initialized" + "; size2buffer-initialized-by-create2buffer4lpu to: " + str(task4create2lpu ['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 278528
            
            code2ack  = code2ack + '7A-'
            
            # -----------------------------------------------------------------------------------------
            # (8) ARENA TO LPU - REQUIRED 
            # ----------------------------------------------------------------------------------------- 
            arena2lpu = None
            message2print = "{(Step 8A/70) try" + "; size2buffer-try-by-create2buffer4lpu: " + str(task4create2lpu ['SIZE']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            try:
                arena2lpu = Arena4Xi(task4create2lpu ['SIZE'])
                message2print = "{(Step 8B1/70) created" + "; arena2lpu-initialized-by-create2buffer4lpu to: " + str(arena2lpu)  + "; time: " + time4xi() + "}"   
                print4xi(class2print, method2print, message2print)
                # <arena4xi.Arena4Xi object at 0x0000000003AB9E48>   
                
                size2lpu = None
                try:
                    size2lpu = arena2lpu.size                                                                       # 
                
                    message2print = "{(Step 8B2/70) got" + "; size2lpu-got-by-create2buffer4lpu: " + str(size2lpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 278528  
                    
                    name2lpu = arena2lpu.name                                                                       # 
                
                    message2print = "{(Step 8B3/70) got" + "; name2lpu-got-by-create2buffer4lpu: " + str(name2lpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # pym-2204-0                     

                except:
                    message2print = "{(Step 8Z1/70) failed" + "; size2lpu-failed-by-create2buffer4lpu: " + str(size2lpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    
                code2ack  = code2ack + '8A-'             
            except:
                task4create2lpu ['SIZE'] = int(task4create2lpu ['SIZE']/8)                                    # RE-ADJUST AND TRY GET LESS MEMORY
                
                message2print = "{(Step 8C/70) set" + "; size2buffer-set-by-create2buffer4lpu to: " + str(task4create2lpu ['SIZE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                try:
                    arena2lpu = Arena4Xi(task4create2lpu ['SIZE'])
                    message2print = "{(Step 8D/70) created" + "; arena2lpu-initialized-by-create2buffer4lpu to: " + str(arena2lpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                
                    code2ack  = code2ack + '8D-'
                                          
                except:
                    message2print = "{(Step 8Z270) failed" + "; arena2lpu-failed-by-create2buffer4lpu: " + str(arena2lpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    code2nack  = code2nack + '8Z-' 
                   
            task4create2lpu ['POINTER2BUFFER'] = arena2lpu.buffer       
            
            message2print = "{(Step 8E/70) set" + "; buffer-set-by-create2buffer4lpu to: " + str(task4create2lpu ['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <mmap.mmap object at 0x0000000004341088>; time: 23:27:47 09/01/11 Pacific Daylight Time}  
            
            code2ack  = code2ack + '8E-'
                            
            # ---------------------------------------------------------------------------------------------
            # (9) ERROR CODE - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu ['CODE2ERROR'] = 0                                                                   # 
              
            message2print = "{(Step 9A/70) created" + "; code2error-initialized-by-create2buffer4lpu to: " + str(task4create2lpu ['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '9A-'
                                        
            # ---------------------------------------------------------------------------------------------
            # (10) REFERENCE COUNT - REQUIRED FOR RETAIN(ATTACH) AND RELEASE                       
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu ['COUNT2REFERENCE'] = 0                                                              # USED TO RETAIN(ATTACH) AND RELEASE BUFFER
              
            message2print = "{(Step 10A/70) created" + "; count2reference-initialized-by-create2buffer4lpu to: " + str(task4create2lpu ['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '10A-'
            
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2lpu-yielded-by-create2buffer4lpu: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        code2nack  = code2nack + '1Z1-' 

    lpu2buffer4xi = {}                                                                                           # INITIALIZE LPU BUFFER                                                                                     

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2lpu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2buffer4lpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'DATA2CALLBACK' in keys2task:
                                                                                                                    # CREATE! 
        message2print = "{(Step 11A/70) try" + "; data2callback-try-by-create2buffer4lpu: " + str(lpu2buffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 11/70) - DATA2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['DATA2CALLBACK'] = task4create2lpu['DATA2CALLBACK']
            
            message2print = "{(Step 11B/70) initialized" + "; data2callback-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4lpu-failed ; time: 05:25:33 05/23/11 Pacific Daylight Time}',
            #  'CLASS': 'create2buffer4lpu', 'METHOD': 'create2buffer4lpu'}; time: 05:25:33 05/23/11 Pacific Daylight Time}
     
            code2ack  = code2ack + '11B-'
        except: 
            message2print = "{(Step 11Z1/70) yielded" + "; data2callback-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '11Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 12A/70) try" + "; function2callback-try-by-create2buffer4lpu: " + str(lpu2buffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 12/70) - FUNCTION2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['FUNCTION2CALLBACK'] = task4create2lpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 12B/70) initialized" + "; function2callback-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2buffer4lpu at 0x0000000003770B48>
             
            code2ack  = code2ack + '12B-'
        except: 
            message2print = "{(Step 12Z1/70) yielded" + "; function2callback-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '12Z1-' 
               

    if 'CONTEXT' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 13/70) - CONTEXT - REQUIRED
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['CONTEXT'] = task4create2lpu['CONTEXT']
            
            message2print = "{(Step 13B/70) initialized" + "; context-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 05:25:33 05/23/11 Pacific Daylight Time}',
            #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x0000000003760448>,
            #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
            #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
            #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 05:25:33 05/23/11 Pacific Daylight Time}
    
            code2ack  = code2ack + '13B-'
        except: 
            message2print = "{(Step 13Z1/70) yielded" + "; context-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '13Z1-' 

    if 'DEVICE' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 14/70) - DEVICE - EXTRA
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['DEVICE'] = task4create2lpu['DEVICE']
            
            message2print = "{(Step 14B/70) initialized" + "; device-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
            #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4,
            #  'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
            #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
            #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8,
            #  'VERSION2DRIVER': '2.0',
            #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
            #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
            #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
            #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
            #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
            #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
            #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK',
            #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64,
            #  'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
            #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little',
            #  'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
            #  'TYPE': 'CL_DEVICE_TYPE_LPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}; time: 05:25:33 05/23/11 Pacific Daylight Time}
     
            code2ack  = code2ack + '14B-'
        except: 
            message2print = "{(Step 14Z1/70) yielded" + "; device-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '14Z1-'         

    if 'FLAGS' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 15/70) - FLAGS - REQUIRED
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['FLAGS'] = task4create2lpu ['FLAGS'] 
            
            message2print = "{(Step 15B/70) initialized" + "; flags-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0 
            
            code2ack  = code2ack + '15B-'
        except: 
            message2print = "{(Step 15Z1/70) yielded" + "; flags-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '15Z1-'     


    if 'SIZE' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 16/70) - SIZE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['SIZE'] = task4create2lpu ['SIZE'] 
            
            message2print = "{(Step 16B/70) initialized" + "; size-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 278528
            code2ack  = code2ack + '16B-'
        except: 
            message2print = "{(Step 16Z1/70) yielded" + "; size-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '16Z1-'             

    if 'POINTER2BUFFER' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 17/70) - POINTER2BUFFER - REQUIRED
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['POINTER2BUFFER'] = task4create2lpu ['POINTER2BUFFER'] 
            
            message2print = "{(Step 17B/70) initialized" + "; pointer2buffer-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '17B-'
        except: 
            message2print = "{(Step 17Z1/70) yielded" + "; pointer2buffer-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '17Z1-'    

    if 'CODE2ERROR' in keys2task:             
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 18/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['CODE2ERROR'] = task4create2lpu['CODE2ERROR']
            
            message2print = "{(Step 18B/70) initialized" + "; code2error-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            code2ack  = code2ack + '18B-'
        except: 
            message2print = "{(Step 18Z1/70) yielded" + "; code2error-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '18Z1-'                

    if 'COUNT2REFERENCE' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 19/70) - REFERENCE COUNT - MUST FOR MANAGEMENT
            # -----------------------------------------------------------------------------------------               
            lpu2buffer4xi['COUNT2REFERENCE'] = task4create2lpu['COUNT2REFERENCE']
            
            message2print = "{(Step 19B/70) initialized" + "; reference-initialized-by-create2buffer4lpu to: " + str(lpu2buffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0 
            code2ack  = code2ack + '19B-'
        except: 
            message2print = "{(Step 19Z1/70) yielded" + "; reference-lpu2buffer4xi-yielded-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '19Z1-'                     
            

                                                 
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    lpu2buffer4xi ['ACK2RETURN']  = code2ack
    lpu2buffer4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; lpu2buffer4xi-returning-by-create2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0,
    #  'COUNT2REFERENCE': 0,
    #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4lpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2buffer4lpu',
    #  'METHOD': 'create2buffer4lpu'},
    #  'FUNCTION2CALLBACK': <function trace2buffer4lpu at 0x00000000039E32C8>,
    #  'POINTER2BUFFER': <mmap.mmap object at 0x00000000042EA088>,
    #  'FLAGS': 0,
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x00000000032BAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
    #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568',
    #  'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4,
    #  'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536,
    #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
    #  'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8,
    #  'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768,
    #  'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4,
    #  'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033,
    #  'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD',
    #  'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16,
    #  'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
    #  'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
    #  'TYPE': 'CL_DEVICE_TYPE_LPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}; time: 00:14:43 09/02/11 Pacific Daylight Time}


    return lpu2buffer4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2subbuffer4lpu" usage = "
#     
#   subbuffer4xi = {}        
#   try:
#       subbuffer4xi['LPU'] = create2subbuffer4lpu()                                                        # LPU subbuffer      
#       message2print = "{(Step 2B/33) initialized" + "; lpu-subbuffer4xi-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)     
#       ....                                                                                                      # subbuffer of devices
#   except:
#       message2print = "{(Step 3Z1/33) yielded" + "; subbuffer4xi-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                              
#
#">

# -------------------------------------------------------------------------------------------------   
def create2subbuffer4lpu(task4create2lpu=None):

    '''
    creates lpu2subbuffer4xi
    '''
    
    global lpu2subbuffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2subbuffer4lpu" 
    method2print = "create2subbuffer4lpu"

    message2print = "{(Step 1A/70) started" + "; create2subbuffer4lpu-started: " + str(create2subbuffer4lpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2lpu-to-create2subbuffer4lpu: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    lpu2subbuffer4xi = {}                                                                                        # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2lpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO LPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4create2lpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2lpu-initialized-by-create2subbuffer4lpu to: " + str(task4create2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            function2callback4lpu = trace2subbuffer4lpu                                                       # CALLBACK FUNCTION FOR LPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4lpu-initialized-by-create2subbuffer4lpu to: " + str(function2callback4lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2subbuffer4lpu"                                                    # MODULE OF LPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2subbuffer4lpu"                                                    # FUNCTION OF LPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2subbuffer4lpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR LPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-initialized-by-create2subbuffer4lpu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '1E-'
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACK - EXTRA                      
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu['DATA2CALLBACK'] = args2callback                                                     # USER DATA PASSED TO LPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2lpu['FUNCTION2CALLBACK'] = function2callback4lpu                                      # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) set" + "; task4create2lpu-initialized-by-create2subbuffer4lpu to: " + str(task4create2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                     
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-initialized-by-create2subbuffer4lpu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2subbuffer4lpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2subbuffer4lpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4create2lpu['PLATFORM'] = platform2xi                                                            # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - NEEDED TO CREATE BUFFER                      
            # ---------------------------------------------------------------------------------------------    
            context2lpu = None
            message2print = "{(Step 3A/70) trying" + "; context2lpu-trying-by-create2subbuffer4lpu: " + str(context2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2lpu = get2context4lpu()                                                               # NO PARAMETERS - THE SYSTEM CREATES   
                
                message2print = "{(Step 3B/70) got" + "; context2lpu-got-by-create2subbuffer4lpu: " + str(context2lpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # 
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2lpu-failed-by-create2subbuffer4lpu: " + str(context2lpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
            task4create2lpu ['CONTEXT'] = context2lpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - EXTRA                        
            # ---------------------------------------------------------------------------------------------    
            device2lpu = None
            message2print = "{(Step 4A/70) trying" + "; device2lpu-trying-by-create2subbuffer4lpu: " + str(device2lpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2lpu = get2lpu4xi()                                                                     # NO PARAMETERS - THE SYSTEM CREATES    
                
                message2print = "{(Step 4B/70) got" + "; device2lpu-got-by-create2subbuffer4lpu: " + str(device2lpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # 
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2lpu-failed-by-create2subbuffer4lpu: " + str(device2lpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4create2lpu ['DEVICE'] = device2lpu
            
            # ---------------------------------------------------------------------------------------------
            # (6) DEFINE FLAGS - NEEDED TO CREATE BUFFER                         
            # ---------------------------------------------------------------------------------------------         
            task4create2lpu ['FLAGS'] = 0b00000000000000000000000000000000
            message2print = "{(Step 6A/70) initialized" + "; flags-initialized-by-create2subbuffer4lpu to: " + str(task4create2lpu ['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            code2ack  = code2ack + '6A-'         
        
            # ---------------------------------------------------------------------------------------------
            # (7) DEFINE SIZE OF MEMORY OBJECT - NEEDED TO CREATE BUFFER                        
            # ---------------------------------------------------------------------------------------------         
            task4create2subbuffer ['SIZE'] = 8192*4
            message2print = "{(Step 7A/70) initialized" + "; size2subbuffer-initialized-by-create2subbuffer4lpu to: " + str(task4create2lpu ['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            code2ack  = code2ack + '7A-'
            
            # -----------------------------------------------------------------------------------------
            # (8) ARENA TO LPU - NEEDED TO CREATE BUFFER  
            # ----------------------------------------------------------------------------------------- 
            arena2lpu = None
            message2print = "{(Step 8A/70) try" + "; size2subbuffer-try-by-create2subbuffer4lpu: " + str(task4create2lpu ['SIZE']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            try:
                arena2lpu = Arena4Xi(task4create2subbuffer ['SIZE'])
                message2print = "{(Step 8B/70) created" + "; arena2lpu-initialized-by-create2subbuffer4lpu to: " + str(arena2lpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + '8A-'             
            except:
                task4create2subbuffer ['SIZE'] = int(task4create2subbuffer ['SIZE']/4)                              # RE-ADJUST AND TRYGET LESS MEMORY
                
                message2print = "{(Step 8C/70) set" + "; size2subbuffer-set-by-create2subbuffer4lpu to: " + str(task4create2lpu ['SIZE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                try:
                    arena2lpu = Arena4Xi(task4create2subbuffer ['SIZE'])
                    message2print = "{(Step 8D/70) created" + "; arena2lpu-initialized-by-create2subbuffer4lpu to: " + str(arena2lpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                
                    code2ack  = code2ack + '8D-'
                                          
                except:
                    message2print = "{(Step 8Z/70) failed" + "; arena2lpu-failed-by-create2subbuffer4lpu: " + str(arena2lpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    code2nack  = code2nack + '8Z-' 
                   
            task4create2subbuffer ['POINTER2BUFFER'] = arena2lpu.buffer       
            
            message2print = "{(Step 8E/70) set" + "; buffer-set-by-create2subbuffer4lpu to: " + str(task4create2subbuffer ['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            code2ack  = code2ack + '8E-'
                            
            # ---------------------------------------------------------------------------------------------
            # (9) ERROR CODE - NEEDED TO CREATE BUFFER                      
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu ['CODE2ERROR'] = 0                                                                   # 
              
            message2print = "{(Step 9A/70) created" + "; code2error-initialized-by-create2subbuffer4lpu to: " + str(task4create2lpu ['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '9A-'
                                        
            # ---------------------------------------------------------------------------------------------
            # (10) REFERENCE COUNT - REQUIRED FOR RETAIN(ATTACH) AND RELEASE                       
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu ['COUNT2REFERENCE'] = 0                                                              # USED TO RETAIN(ATTACH) AND RELEASE BUFFER
              
            message2print = "{(Step 10A/70) created" + "; count2reference-initialized-by-create2subbuffer4lpu to: " + str(task4create2lpu ['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '10A-'
                                        
            # ---------------------------------------------------------------------------------------------
            # (11) BUFFER - NEEDED TO CREATE SUBBUFFER                  
            # ---------------------------------------------------------------------------------------------              
            buffer2lpu = None
            message2print = "{(Step 11Z/70) yielded" + "; buffer2lpu-yielded-by-create2subbuffer4lpu: " + str(buffer2lpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            
            try:
                buffer2lpu = create2buffer4lpu(task4create2lpu)                                            # CREATE BUFFER   
                
                message2print = "{(Step 11A/70) created" + "; buffer2lpu-initialized-by-create2subbuffer4lpu to: " + str(buffer2lpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                task4create2lpu ['BUFFER'] = buffer2lpu
                
                message2print = "{(Step 11A/70) set" + "; buffer2lpu-set-by-create2subbuffer4lpu to: " + str(task4create2lpu ['BUFFER'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                code2ack  = code2ack + '11A-'                                                      
            except:
                message2print = "{(Step 11Z/70) yielded" + "; buffer2lpu-yielded-by-create2subbuffer4lpu: " + str(buffer2lpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                                        
            # ---------------------------------------------------------------------------------------------
            # (12) TYPE - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu ['TYPE'] = 'REGION'                                                                  # TYPE 
              
            message2print = "{(Step 12A/70) set" + "; type-set-by-create2subbuffer4lpu to: " + str(task4create2lpu ['TYPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '12A-' 
                                                    
            # ---------------------------------------------------------------------------------------------
            # (13) OFFSET - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu ['OFFSET'] = 8192                                                                    # OFFSET TO BUFFER 
              
            message2print = "{(Step 13A/70) set" + "; offset-set-by-create2subbuffer4lpu to: " + str(task4create2lpu ['OFFSET'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '13A-' 
                                                    
            # ---------------------------------------------------------------------------------------------
            # (14) SIZE - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2lpu ['SIZE'] = int(buffer2lpu['SIZE'] / 8)                                            # REGION SIZE
              
            message2print = "{(Step 14A/70) set" + "; offset-set-by-create2subbuffer4lpu to: " + str(task4create2lpu ['OFFSET'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '14A-'       
      
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2lpu-yielded-by-create2subbuffer4lpu: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        code2nack  = code2nack + '1Z1-' 

    lpu2subbuffer4xi = {}                                                                                        # INITIALIZE LPU BUFFER                                                                                     

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2lpu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2subbuffer4lpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'DATA2CALLBACK' in keys2task:
                                                                                                                        
        message2print = "{(Step 11A/70) try" + "; data2callback-try-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 11/70) - DATA2CALLBACK - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['DATA2CALLBACK'] = task4create2lpu['DATA2CALLBACK']
            
            message2print = "{(Step 11B/70) initialized" + "; data2callback-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '11B-'
        except: 
            message2print = "{(Step 11Z1/70) yielded" + "; data2callback-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '11Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 12A/70) try" + "; function2callback-try-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 12/70) - FUNCTION2CALLBACK - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['FUNCTION2CALLBACK'] = task4create2lpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 12B/70) initialized" + "; function2callback-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '12B-'
        except: 
            message2print = "{(Step 12Z1/70) yielded" + "; function2callback-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '12Z1-' 
               

    if 'CONTEXT' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 13/70) - CONTEXT - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['CONTEXT'] = task4create2lpu['CONTEXT']
            
            message2print = "{(Step 13B/70) initialized" + "; context-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '13B-'
        except: 
            message2print = "{(Step 13Z1/70) yielded" + "; context-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '13Z1-' 

    if 'DEVICE' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 14/70) - DEVICE - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['DEVICE'] = task4create2lpu['DEVICE']
            
            message2print = "{(Step 14B/70) initialized" + "; device-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '14B-'
        except: 
            message2print = "{(Step 14Z1/70) yielded" + "; device-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '14Z1-'         

    if 'FLAGS' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 15/70) - FLAGS - REQUIRED FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['FLAGS'] = task4create2lpu ['FLAGS'] 
            
            message2print = "{(Step 15B/70) initialized" + "; flags-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '15B-'
        except: 
            message2print = "{(Step 15Z1/70) yielded" + "; flags-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '15Z1-'     
    

    if 'SIZE' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 16/70) - SIZE - REQUIRED FOR REGION
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['SIZE'] = task4create2lpu ['SIZE'] 
            
            message2print = "{(Step 16B/70) initialized" + "; size-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '16B-'
        except: 
            message2print = "{(Step 16Z1/70) yielded" + "; size-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '16Z1-'             

    if 'POINTER2BUFFER' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 17/70) - POINTER2BUFFER - EXTRA - MIGHT BE USEFUL TO CALCULATE
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['POINTER2BUFFER'] = task4create2lpu ['POINTER2BUFFER'] 
            
            message2print = "{(Step 17B/70) initialized" + "; pointer2subbuffer-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '17B-'
        except: 
            message2print = "{(Step 17Z1/70) yielded" + "; pointer2subbuffer-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '17Z1-'    

    if 'CODE2ERROR' in keys2task:             
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 18/70) - ERROR CODE - REQUIRED FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['CODE2ERROR'] = task4create2lpu['CODE2ERROR']
            
            message2print = "{(Step 18B/70) initialized" + "; code2error-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '18B-'
        except: 
            message2print = "{(Step 18Z1/70) yielded" + "; code2error-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '18Z1-'                

    if 'COUNT2REFERENCE' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 19/70) - REFERENCE COUNT - MUST FOR MANAGEMENT SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['COUNT2REFERENCE'] = task4create2lpu['COUNT2REFERENCE']
            
            message2print = "{(Step 19B/70) initialized" + "; reference-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '19B-'
        except: 
            message2print = "{(Step 19Z1/70) yielded" + "; reference-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '19Z1-'                     

    if 'BUFFER' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 20/70) - BUFFER - REQUIRED TO TAKE FROM
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['BUFFER'] = task4create2lpu['BUFFER']
            
            message2print = "{(Step 20B/70) initialized" + "; buffer-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '20B-'
        except: 
            message2print = "{(Step 20Z/70) yielded" + "; buffer-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '20Z-' 

    if 'TYPE' in keys2task:                         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21/70) - TYPE - REQUIRED - REGION
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['TYPE'] = task4create2lpu['TYPE']
            
            message2print = "{(Step 21B/70) initialized" + "; type-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['TYPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '21B-'
        except: 
            message2print = "{(Step 21Z/70) yielded" + "; type-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z-' 

    if 'OFFSET' in keys2task:                                      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22/70) - OFFSET - REQUIRED FOR REGION
            # -----------------------------------------------------------------------------------------               
            lpu2subbuffer4xi['OFFSET'] = 8192
            
            message2print = "{(Step 22B/70) initialized" + "; offset-initialized-by-create2subbuffer4lpu to: " + str(lpu2subbuffer4xi['OFFSET'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '22B-'
        except: 
            message2print = "{(Step 22Z/70) yielded" + "; offset-lpu2subbuffer4xi-yielded-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z-'           

    if 'COUNT2REFERENCE' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - ADD REFERENCE COUNT TO BUFFER DUE TO NEW SUB-BUFFER ADDED TO IT               
            # -----------------------------------------------------------------------------------------    
            task4retain2lpu = {}
            task4retain2lpu ['COUNT2REFERENCE'] = 1                                                              # REFERENCE COUNT
    
            response4retain2lpu = {}
                              
            response4retain2lpu = retain2buffer4lpu(task4retain2lpu)                                       # COUNT2REFERENCE                                                      
            
            message2print = "{(Step 22B/70) added" + "; referencecount-added-by-create2subbuffer4lpu: " + str(response4retain2lpu) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + '22B-'
        except:
            message2print = "{(Step 23Z/70) yielded" + "; referencecount-yielded-by-create2subbuffer4lpu: " + str(response4retain2lpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '22Z-' 
                                                                           
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    lpu2subbuffer4xi ['ACK2RETURN']  = code2ack
    lpu2subbuffer4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; lpu2subbuffer4xi-returning-by-create2subbuffer4lpu: " + str(lpu2subbuffer4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0,
    #  'COUNT2REFERENCE': 0,
    #  'BUFFER': {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004903138>,
    #  'ACK2RETURN': ' ',
    #  'COUNT2REFERENCE': 1,
    #  'NACK2RETURN': ' 1Z1-',
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x00000000032BAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792},
    #  'POINTER2BUFFER': <mmap.mmap object at 0x0000000004903138>, 'FLAGS': 0,
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x00000000032BAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'OFFSET': 8192, 'NACK2RETURN': ' 11Z1-12Z1-14Z1-', 'ACK2RETURN': ' 13B-15B-16B-17B-18B-19B-20B-21B-22B-22B-',
    #  'TYPE': 'REGION', 'SIZE': 4224}; time: 00:14:44 09/02/11 Pacific Daylight Time}

    
    return lpu2subbuffer4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2buffer4lpu" usage = "
#
#    # Example (from buffer4xi.py - task4set2lpu got as parameter - see buffer4xi5test.py)
#
#    if buffer4xi is None:
#        buffer4xi = create2buffer4xi()                                                                            # CREATE COMMANDQUEUE4XI
#    try:
#        # -----------------------------------------------------------------------------
#        # (Step 4A/33)
#        # ----------------------------------------------------------------------------- 
#        message2print = "{(Step 4A/33) passing" + "; task-passing-to-set2buffer4lpu: " + str(task4set2lpu['LPU'])  + "; time: " + time4xi() + "}"  
#        print4xi(class2print, method2print, message2print)                                                         
#        
#        buffer4xi ['LPU'] = set2buffer4lpu(task4set2lpu['LPU'])                                           # 
#          
#        message2print = "{(Step 4B/33) set" + "; lpu-buffer-set-by-set2buffer4lpu to: " + str(buffer4xi ['LPU'])  + "; time: " + time4xi() + "}"
#        print4xi(class2print, method2print, message2print)                                                          
#        code2ack  = code2ack + '4B-'
#   except:
#        message2print = "{(Step 4Z1/33) yielded" + "; lpu-yielded-by-set2buffer4xi: " + 'LPU' + "; time: " + time4xi() + "}"
#        print4xi(class2print, method2print, message2print) 
#        code2nack  = code2nack + '4Z1-'
#">

# -------------------------------------------------------------------------------------------------   
def set2buffer4lpu(task4set2lpu=None):

    '''
    sets lpu2buffer4xi
    '''

    global lpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2buffer4lpu"
    method2print = "set2buffer4lpu"

    message2print = "{(Step 1A/33) started" + "; set2buffer4lpu-started: " + str(set2buffer4lpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4set2lpu-to-set2buffer4lpu: " + str(task4set2lpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if lpu2buffer4xi is None:
            lpu2buffer4xi = create2buffer4lpu()                                                               # INITIALIZE BUFFER FOR LPU                      
    except:
        try:
            lpu2buffer4xi = create2buffer4lpu()
        except:
            lpu2buffer4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 9A/70) try" + "; data2callback-try-by-set2buffer4lpu: " + str(lpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 2/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['DATA2CALLBACK'] = task4set2lpu['DATA2CALLBACK']
        
        message2print = "{(Step 9B/70) initialized" + "; data2callback-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '9B-'
    except: 
        message2print = "{(Step 9Z1/70) yielded" + "; data2callback-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '9Z1-'
    
    message2print = "{(Step 10A/70) try" + "; function2callback-try-by-set2buffer4lpu: " + str(lpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 10/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['FUNCTION2CALLBACK'] = task4set2lpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 10B/70) initialized" + "; function2callback-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '10B-'
    except: 
        message2print = "{(Step 10Z1/70) yielded" + "; function2callback-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '10Z1-' 
           
    message2print = "{(Step 11A/70) try" + "; info2private-try-by-set2buffer4lpu: " + str(lpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11/70) - INFO2PRIVATE - EXTRA
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['INFO2PRIVATE'] = task4set2lpu['INFO2PRIVATE']
        
        message2print = "{(Step 11B/70) initialized" + "; info2private-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '11B-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; info2private-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-'             
    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12/70) - CONTEXT
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['CONTEXT'] = task4set2lpu['CONTEXT']
        
        message2print = "{(Step 12B/70) initialized" + "; context-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '12B-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; context-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13/70) - DEVICE
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['DEVICE'] = task4set2lpu['DEVICE']
        
        message2print = "{(Step 13B/70) initialized" + "; device-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '13B-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; device-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-'         

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14/70) - PROPERTIES (EXECUTION and PROFILING)
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['PROPERTIES'] = task4set2lpu['PROPERTIES']
        
        message2print = "{(Step 14B/70) initialized" + "; properties-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '14B-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; properties-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'     

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 15/70) - ERROR CODE
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['CODE2ERROR'] = task4set2lpu['CODE2ERROR']
        
        message2print = "{(Step 15B/70) initialized" + "; code2error-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '15B-'
    except: 
        message2print = "{(Step 15Z1/70) yielded" + "; code2error-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '15Z1-'                
                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 16/70) - REFERENCE COUNT
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['COUNT2REFERENCE'] = task4set2lpu['COUNT2REFERENCE']
        
        message2print = "{(Step 16B/70) initialized" + "; reference-initialized-by-set2buffer4lpu to: " + str(lpu2buffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '16B-'
    except: 
        message2print = "{(Step 16Z1/70) yielded" + "; reference-lpu2buffer4xi-yielded-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '16Z1-'                     
            
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    lpu2buffer4xi ['ACK2RETURN']  = code2ack
    lpu2buffer4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; lpu2buffer4xi-returning-by-set2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'CODE2ERROR': 0,
    #  'COUNT2REFERENCE': 0,
    #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4lpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2buffer4lpu',
    #  'METHOD': 'create2buffer4lpu'},
    #  'FUNCTION2CALLBACK': <function trace2buffer4lpu at 0x0000000003F432C8>,
    #  'POINTER2BUFFER': <mmap.mmap object at 0x000000000434BFA8>,
    #  'FLAGS': 0,
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x00000000032CAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318,
    #  'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2,
    #  'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
    #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write',
    #  'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536,
    #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
    #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
    #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
    #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
    #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK',
    #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64,
    #  'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
    #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little',
    #  'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_LPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'NACK2RETURN': ' 9Z1-10Z1-11Z1-14Z1-15Z1-16Z1-', 'ACK2RETURN': ' 12B-13B-', 'SIZE': 278528}; time: 01:27:58 09/02/11 Pacific Daylight Time}


    return lpu2buffer4xi

            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2buffer4lpu" usage = "
#
#   # Example (see buffer4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECRENTING COUNT WITH 1             
#   task4release2buffer = {}
#   task4release2buffer ['LPU'] = {} 
#    
#   task4release2buffer ['LPU'] ['COUNT2REFERENCE'] = 1                                                          # REFERENCE COUNT
#   response4release2buffer = {}
#   
#   print('(Step 5A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO RELEASE BUFFEROF LPU DEVICE ', time4xi())  
#   try:                               
#       response4release2buffer = release2buffer4xi(task4release2buffer)                                            # COUNT2REFERENCE                                                      
#       print('(Step 5BD/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4RELEASE2BUFFER: ', response4release2buffer)                          
#       
#   except:
#       print('(Step 5Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO RELEASE BUFFEROF LPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def release2buffer4lpu(task4release2lpu=None):

    '''
    releases lpu2buffer4xi
    '''
    
    global lpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2buffer4lpu"
    method2print = "release2buffer4lpu" 

    message2print = "{(Step 1A/33) started" + "; release2buffer4lpu-started: " + str(release2buffer4lpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4release2lpu-to-release2buffer4lpu: " + str(task4release2lpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if lpu2buffer4xi is None:
            lpu2buffer4xi = create2buffer4lpu()                                                               # INITIALIZE BUFFER                
    except:
        try:
            lpu2buffer4xi = create2buffer4lpu()
        except:
            lpu2buffer4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; lpu2buffer4xi-yielded-by-release2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2buffer4lpu: " + str(lpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2lpu is None:
        task4release2lpu = {}
        task4release2lpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        lpu2buffer4xi['COUNT2REFERENCE'] = lpu2buffer4xi['COUNT2REFERENCE'] - task4release2lpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2buffer4lpu: " + str(lpu2buffer4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if lpu2buffer4xi['COUNT2REFERENCE'] < 0:
            lpu2buffer4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2buffer4lpu: " + " ** " + str(lpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            lpu2buffer4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2buffer4lpu: " + " ** " + str(lpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; lpu2buffer4xi-yielded-by-release2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    lpu2buffer4xi ['ACK2RETURN']  = code2ack
    lpu2buffer4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; lpu2buffer4xi-returning-by-release2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 8Z1-',
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 04:38:48 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x000000000357E448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568',
    #  'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472,
    #  'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
    #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE4CONSTANT': 65536,
    #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
    #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768,
    #  'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
    #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
    #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK',
    #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64,
    #  'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
    #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little',
    #  'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_LPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'PROPERTIES': None}; time: 04:38:48 05/21/11 Pacific Daylight Time}
 
    
    return lpu2buffer4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2buffer4lpu" usage = "
#
#   # Example (see buffer4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAIND BY INCREMENTING COUNT WITH 1             
#   task4retain2buffer = {}
#   task4retain2buffer ['LPU'] = {} 
#    
#   task4retain2buffer ['LPU'] ['COUNT2REFERENCE'] = 1                  # ADD REFERENCE COUNT BY 1
#   response4retain2buffer = {}
#   
#   print('(Step 5A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO RETAIN BUFFEROF LPU DEVICE ', time4xi())  
#   try:                               
#       response4retain2buffer = retain2buffer4xi(task4retain2buffer)                                                                                          
#       print('(Step 5BD/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4RETAIN2BUFFER: ', response4retain2buffer)                          
#       
#   except:
#       print('(Step 5Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO RETAIN BUFFEROF LPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def retain2buffer4lpu(task4retain2lpu=None):

    '''
    retains lpu2buffer4xi
    '''
    global lpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2buffer4lpu"
    method2print = "retain2buffer4lpu"

    message2print = "{(Step 1A/33) started" + "; retain2buffer4lpu-started: " + str(retain2buffer4lpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # <function retain2buffer4lpu at 0x000000000392F448> 
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2lpu-to-retain2buffer4lpu: " + str(task4retain2lpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if lpu2buffer4xi is None:
            lpu2buffer4xi = create2buffer4lpu()                                                               # INITIALIZE BUFFER                
    except:
        try:
            lpu2buffer4xi = create2buffer4lpu()
        except:
            lpu2buffer4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; lpu2buffer4xi-yielded-by-retain2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; retain-try-by-retain2buffer4lpu: " + str(lpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x0000000003FB36A0>, 
    #      'ACK2RETURN': ' 13B-15B-16B-17B-', 
    #     'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-', 
    #       'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 00:44:53 05/25/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x00000000038D36C8>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 
    #         'FLAGS': 0, 
    #          'SIZE': 33792
    # }; time: 00:44:54 05/25/11 Pacific Daylight Time}
       
    try:
        # -----------------------------------------------------------------------------------------
        # RETAIN  
        # -----------------------------------------------------------------------------------------               
        message2print = "{(Step 1B1/70) using" + "; current2reference-using-by-retain2buffer4lpu: " + str(lpu2buffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
        
        message2print = "{(Step 1B2/70) using" + "; add2reference-using-by-retain2buffer4lpu: " + str(task4retain2lpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 1
        
        lpu2buffer4xi['COUNT2REFERENCE'] = int(lpu2buffer4xi['COUNT2REFERENCE']) + int(task4retain2lpu['COUNT2REFERENCE'])
        
        message2print = "{(Step 1C/70) calculated" + "; count2reference-calculated-by-retain2buffer4lpu: " + str(lpu2buffer4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
         
        if lpu2buffer4xi['COUNT2REFERENCE'] <= 0:
            lpu2buffer4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1D/70) warning" + "; count2reference-warning-by-retain2buffer4lpu: " + " ** " + str(lpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
                
            code2nack  = code2nack + '1D-'
        else:
            code2ack  = code2ack + '1D-'
        #
    except:
        try:
            lpu2buffer4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1Z1/70) warning" + "; count2reference-warning-by-retain2buffer4lpu: " + " ** " + str(lpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '1Z1-'
            
        except:
            message2print = "{(Step 1Z2/70) yielded" + "; lpu2buffer4xi-yielded-by-retain2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)            
    # -----------------------------------------------------------------------------------------
    lpu2buffer4xi ['ACK2RETURN']  = code2ack
    lpu2buffer4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; lpu2buffer4xi-returning-by-retain2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    return lpu2buffer4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2bufferinfo4lpu" usage = "
#
#   try:                               
#       response4get2lpu = get2bufferinfo4lpu()                                        
#                                                                                                                   
#   except:
#       ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2bufferinfo4lpu():

    '''
    gets lpu2buffer4xi
    '''
    
    global lpu2buffer4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2bufferinfo4lpu"
    method2print = "get2bufferinfo4lpu"

    message2print = "{(Step 1A/33) started" + "; get2bufferinfo4lpu-started: " + str(get2bufferinfo4lpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                                                               
    try: 
        if lpu2buffer4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            lpu2xi = create2buffer4lpu()
            message2print = "{(Step 1B/33) initialized" + "; lpu2xi-initialized-by-get2bufferinfo4lpu to: " + str(lpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                
        else:
            # -------------------------------------------------------------------------------------
            # RETURN THE EXISTING BUFFER FOR LPU          
            # -------------------------------------------------------------------------------------     
            lpu2xi = lpu2buffer4xi
            message2print = "{(Step 1C/33) got" + "; lpu2xi-got-by-get2bufferinfo4lpu: " + str(lpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            lpu2xi = create2buffer4lpu()
            message2print = "{(Step 1D/33) initialized" + "; lpu2xi-initialized-by-get2bufferinfo4lpu to: " + str(lpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                        
        except:
            lpu2xi = None
            message2print = "{(Step 1Z2/70) yielded" + "; lpu2buffer4xi-yielded-by-get2buffer4lpu: " + str(lpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                        
    message2print = "{(Step 33/33) returning" + "; lpu2xi-returning-by-get2bufferinfo4lpu: " + str(lpu2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #  
    
    return lpu2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "LPU2Buffer4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for LPU buffer" usage = "Buffer4Xi of LPU"
#>

# =================================================================================================
class LPU2Buffer4Xi(object): 
    ''' 
    LPU2Buffer4Xi offers  methods for LPU buffer
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2lpu = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2lpu',
    'get2lpu',
    'release2lpu',
    'retain2lpu',
    'set2lpu',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-LPU2Buffer4Xi" usage = "
    # try:
    #     # ---------------------------------------------------------------------------------------------
    #     # CREATE OBJECT                        
    #     # ---------------------------------------------------------------------------------------------        
    #     cc2xi = LPU2Buffer4Xi()
    #     print('(Step 5B/33) OF LPU4XI5TEST - CREATED LPU2Buffer4Xi OBJECT: ', cc2xi)                                       
    # except:
    #     print('(Step 5Z/33) OF LPU4XI5TEST *** FAILED TO CREATE LPU2Buffer4Xi OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2lpu = None):
        '''
        _init__ method initializes LPU2Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "LPU2Buffer4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 

        message2print = "{(Step 1B/33) borning" + "; lpu2buffer2xi-of-LPU2Buffer4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-lpu2buffer2xi-of-LPU2Buffer4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2lpu-sharing-by-lpu2buffer2xi-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi.classvariable2lpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2lpu-passed-to-init-of-LPU2Buffer4Xi: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                               
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2lpu-passing-to-create2buffer4lpu-by-init-of-LPU2Buffer4Xi: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
        
        lpu2buffer2xi = create2buffer4lpu(task4create2lpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2buffer4lpu-performed-by-init-of-LPU2Buffer4Xi: " + str(create2buffer4lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; lpu2buffer2xi-of-LPU2Buffer4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-lpu2buffer2xi-of-LPU2Buffer4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2lpu-shared-by-lpu2buffer2xi-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi.classvariable2lpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #               
       
        message2print = "{(Step 3D/33) returning" + "; init-of-LPU2Buffer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-LPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF LPU2COMMANDQUEUE4XI - TRYING TO CREATE LPU COMMANDQUEUE')
    # try:
    #     cc2xi = LPU2Buffer4Xi()                            
    #     buffer2lpu = cc2xi.create2lpu()                                  
    #     print('(Step 1B/33) OF LPU4XI5TEST - SET LPU COMMANDQUEUE: ', buffer2lpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF LPU4XI5TEST *** FAILED TO SET LPU BUFFER***')
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2lpu(self, task4create2lpu = None):
        '''
        create2lpu method creates objects of LPU2Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "LPU2Buffer4Xi"
        method2print = "create2lpu"
                     
        message2print = "{(Step 1A/33) started" + "; create2lpu-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4create2lpu-passed-to-create2lpu-of-LPU2Buffer4Xi: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2lpu-passing-to-create2buffer4lpu-by-create2lpu-of-LPU2Buffer4Xi: " + str(task4create2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        lpu2buffer2xi = create2buffer4lpu(task4create2lpu)

        message2print = "{(Step 2B/33) performed" + "; create2buffer4lpu-performed-by-create2lpu-of-LPU2Buffer4Xi: " + str(create2buffer4lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; lpu2buffer2xi-returning-by-create2lpu-of-LPU2Buffer4Xi: " + str(lpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
 
                
        return lpu2buffer2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2lpu-of-LPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF LPU2COMMANDQUEUE4XI - TRYING TO SET LPU COMMANDQUEUE')
    # try:
    #     cc2xi = LPU2Buffer4Xi()                            
    #     buffer2lpu = cc2xi.set2lpu()                                  
    #     print('(Step 1B/33) OF LPU4XI5TEST - SET LPU COMMANDQUEUE: ', buffer2lpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF LPU4XI5TEST *** FAILED TO SET LPU BUFFER***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2lpu(self, task4set2lpu = None):
        '''
        sets LPU2Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "LPU2Buffer4Xi"
        method2print = "set2lpu"
                     
        message2print = "{(Step 1A/33) started" + "; set2lpu-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4set2lpu-passed-to-set2lpu-of-LPU2Buffer4Xi: " + str(task4set2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2lpu-passing-to-set2buffer4lpu-by-set2lpu-of-LPU2Buffer4Xi: " + str(task4set2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        lpu2buffer2xi = set2buffer4lpu(task4set2lpu)

        message2print = "{(Step 2B/33) performed" + "; set2buffer4lpu-performed-by-set2lpu-of-LPU2Buffer4Xi: " + str(set2buffer4lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; lpu2buffer2xi-returning-by-set2lpu-of-LPU2Buffer4Xi: " + str(lpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return lpu2buffer2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2lpu-of-LPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF LPU2COMMANDQUEUE4XI - TRYING TO GET LPU COMMANDQUEUE')
    # try:
    #     cc2xi = LPU2Buffer4Xi()                            
    #     buffer2lpu = cc2xi.get2lpu()                                  
    #     print('(Step 1B/33) OF LPU4XI5TEST - GOT LPU COMMANDQUEUE: ', buffer2lpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF LPU4XI5TEST *** FAILED TO GET LPU BUFFER***')   
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2lpu(self):
        '''
        get2lpu method gets objects of LPU2Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "LPU2Buffer4Xi"
        method2print = "get2lpu"
                     
        message2print = "{(Step 1A/33) started" + "; get2lpu-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        lpu2buffer2xi = get2bufferinfo4lpu()
        
        message2print = "{(Step 2A/33) returning" + "; lpu2buffer2xi-returning-by-get2lpu-of-LPU2Buffer4Xi: " + str(lpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return lpu2buffer2xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2lpu-of-LPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF LPU2COMMANDQUEUE4XI - TRYING TO SET LPU COMMANDQUEUE')
    # try:
    #     cc2xi = LPU2Buffer4Xi()                            
    #     buffer2lpu = cc2xi.release2lpu()                                  
    #     print('(Step 1B/33) OF LPU4XI5TEST - SET LPU COMMANDQUEUE: ', buffer2lpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF LPU4XI5TEST *** FAILED TO SET LPU BUFFER***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2lpu(self, task4release2lpu = None):
        '''
        releases LPU2Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "LPU2Buffer4Xi"
        method2print = "release2lpu"
                     
        message2print = "{(Step 1A/33) started" + "; release2lpu-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4release2lpu-passed-to-release2lpu-of-LPU2Buffer4Xi: " + str(task4release2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2lpu-passing-to-release2buffer4lpu-by-release2lpu-of-LPU2Buffer4Xi: " + str(task4release2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        lpu2buffer2xi = release2buffer4lpu(task4release2lpu)

        message2print = "{(Step 2B/33) performed" + "; release2buffer4lpu-performed-by-release2lpu-of-LPU2Buffer4Xi: " + str(release2buffer4lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; lpu2buffer2xi-returning-by-release2lpu-of-LPU2Buffer4Xi: " + str(lpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return lpu2buffer2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2lpu-of-LPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF LPU2COMMANDQUEUE4XI - TRYING TO SET LPU COMMANDQUEUE')
    # try:
    #     cc2xi = LPU2Buffer4Xi()                            
    #     buffer2lpu = cc2xi.retain2lpu()                                  
    #     print('(Step 1B/33) OF LPU4XI5TEST - SET LPU COMMANDQUEUE: ', buffer2lpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF LPU4XI5TEST *** FAILED TO SET LPU BUFFER***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2lpu(self, task4retain2lpu = None):
        '''
        retains LPU2Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "LPU2Buffer4Xi"
        method2print = "retain2lpu"
                     
        message2print = "{(Step 1A/33) started" + "; retain2lpu-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2lpu-passed-to-retain2lpu-of-LPU2Buffer4Xi: " + str(task4retain2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2lpu-passing-to-retain2buffer4lpu-by-retain2lpu-of-LPU2Buffer4Xi: " + str(task4retain2lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        lpu2buffer2xi = retain2buffer4lpu(task4retain2lpu)

        message2print = "{(Step 2B/33) performed" + "; retain2buffer4lpu-performed-by-retain2lpu-of-LPU2Buffer4Xi: " + str(retain2buffer4lpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; lpu2buffer2xi-returning-by-retain2lpu-of-LPU2Buffer4Xi: " + str(lpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return lpu2buffer2xi
                                                           
    #</methodize4xi>   
                                         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-LPU2Buffer4Xi" usage = "
    # try:
    #     print(cc2xi.sense())
    # 
    #     print('=' *33)          
    #     print('(Step 15B/33) OF LPU4XI5TEST - SENSED ', time4xi())                                                  
    #                                                                                                                 
    #     print('=' *33)
    # except:
    #     print('(Step 15Z/33) OF LPU4XI5TEST *** FAILED TO SENSE ', time4xi())    
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses LPU2Buffer4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'LPU2Buffer4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; LPU2Buffer4Xi-sensing-by-sense-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-LPU2Buffer4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2lpu-of-LPU2Buffer4Xi'] = LPU2Buffer4Xi.classvariable2lpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-LPU2Buffer4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; LPU2Buffer4Xi-sensed-by-sense-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-LPU2Buffer4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                    
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-LPU2Buffer4Xi" usage = "
    # try:
    #     print(cc2xi.reason())
    # 
    #     print('=' *33)          
    #     print('(Step 17B/33) OF LPU4XI5TEST - REASONED ', time4xi())                                                
    #     print('=' *33)       
    # except:
    #     print('(Step 17Z/33) OF LPU4XI5TEST *** FAILED TO REASON ', time4xi())     
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons LPU2Buffer4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'LPU2Buffer4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; LPU2Buffer4Xi-reasoning-by-reason-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-LPU2Buffer4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-LPU2Buffer4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-LPU2Buffer4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; LPU2Buffer4Xi-reasoned-by-reason-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-LPU2Buffer4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                     
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-LPU2Buffer4Xi" usage = "
    # try:
    #     print(cc2xi.ace())
    # 
    #     print('=' *33)          
    #     print('(Step 21B/33) OF LPU4XI5TEST - ACED ', time4xi())                                                    
    #     print('=' *33) 
    # except:
    #     print('(Step 21Z/33) OF LPU4XI5TEST *** FAILED TO ACE ', time4xi())      
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces LPU2Buffer4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'LPU2Buffer4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-LPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; LPU2Buffer4Xi-acing-by-ace-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-LPU2Buffer4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-LPU2Buffer4Xi'] = LPU2Buffer4Xi.classvariable2lpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-LPU2Buffer4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; LPU2Buffer4Xi-aced-by-ace-of-LPU2Buffer4Xi: " + str(LPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-LPU2Buffer4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                              
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   lpu3image4xi5test.txt
#   sense-lpu3image4xi5test.xml
#   reason-lpu3image4xi5test.xml
#   ace-lpu3image4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of lpu2buffer4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
